/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Diff of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.6 Revision 1.48
1# Copyright 1999-2002 Gentoo Technologies, Inc. 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.48 2006/10/16 08:12:01 flameeyes Exp $
4#
5# Author: Diego Pettenò <flameeyes@gentoo.org>
3# Author: Martin Schlemmer <azarah@gentoo.org> 6# Enhancements: Martin Schlemmer <azarah@gentoo.org>
4# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.6 2002/10/25 19:55:52 vapier Exp $
5# The autotools eclass enables building of the apps that needs the latest autconf/automake.
6# 7#
7# NOTES: 8# This eclass is for handling autotooled software packages that
9# needs to regenerate their build scripts.
8# 10#
9# This eclass was made to bridge the incompadibility problem of autoconf-2.13, 11# NB: If you add anything, please comment it!
10# autoconf-2.5x and automake-1.4x, automake-1.5x. Most packages needs
11# autoconf-2.13 and automake-1.4x, but cannot work with the latest versions
12# of these packages due to incompadibility, thus when we have a package that
13# needs the latest versions of automake and autoconf, it begins to get a
14# problem.
15#
16#
17# Commented Example:
18#
19# The following is a commented template for how to use this eclass:
20#
21# #<cut here>
22# # Copyright 1999-2002 Gentoo Technologies, Inc.
23# # Distributed under the terms of the GNU General Public License, v2 or later
24# # Maintainer: John Doe <john@foo.com>
25# # $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.6 2002/10/25 19:55:52 vapier Exp $
26#
27# # If you need to set the versions different from in here, it *must*
28# # be done before inherit.eclass is sourced
29# #ACONFVER=2.52f
30# #AMAKEVER=1.5b
31#
32# # Source inherit.eclass and inherit AutoTools
33# . /usr/portage/eclass/inherit.eclass
34# inherit autotools
35#
36# # This is pretty standard.
37# S=${WORKDIR}/${P}
38# DESCRIPTION="My Application"
39#
40# # Here you *NEED* to have $SRC_URI as a source url to include the automake
41# # and autoconf source tarballs
42# SRC_URI="${SRC_URI}
43# http://download.foo.com/files/${P}.tar.gz"
44#
45# HOMEPAGE="http://www.foo.com/"
46#
47# # Here you *NEED* to have "$DEPEND" as an depend to include the dependancies
48# # of automake and autoconf.
49# DEPEND="${DEPEND}
50# foo-libs/libfoo"
51#
52# src_compile() {
53#
54# # This will install automake and autoconf in a tempory directory and
55# # setup the environment. Do not forget!!!!!!!
56# install_autotools
57#
58# # Now like normal
59# ./configure --host=${CHOST} \
60# --prefix=/usr || die
61# emake || die
62# }
63#
64# src_install() {
65#
66# # Still pretty standard to how you would normally do it
67# make DESTDIR=${D} install || die
68# dodoc AUTHORS COPYING ChangeLog INSTALL NEWS README TODO
69# }
70# #<cut here>
71#
72 12
13inherit eutils libtool
73 14
74ECLASS=autotools 15_automake_atom="sys-devel/automake"
75INHERITED="$INHERITED $ECLASS" 16_autoconf_atom="sys-devel/autoconf"
17if [[ -n ${WANT_AUTOMAKE} ]] && [[ ${WANT_AUTOMAKE} != "latest" ]]; then
18 _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*"
19fi
76 20
77#[ -z "$ACONFVER" ] && ACONFVER=2.52f 21if [[ -n ${WANT_AUTOCONF} ]] ; then
78#[ -z "$AMAKEVER" ] && AMAKEVER=1.5b 22 case ${WANT_AUTOCONF} in
79[ -z "$ACONFVER" ] && die "!!! You need to set \$ACONFVER *before* inheriting the eclass !!!" 23 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;;
80[ -z "$AMAKEVER" ] && die "!!! You need to set \$AMAKEVER *before* inheriting the eclass !!!" 24 2.5) _autoconf_atom=">=sys-devel/autoconf-2.59" ;;
25 esac
26fi
27DEPEND="${_automake_atom}
28 ${_autoconf_atom}
29 sys-devel/libtool"
30RDEPEND=""
31unset _automake_atom _autoconf_atom
81 32
82DESCRIPTION="Based on the $ECLASS eclass" 33# Variables:
83#ASRC_URI="ftp://ftp.gnu.org/gnu/autoconf/autoconf-${ACONFVER}.tar.bz2 34#
84# ftp://alpha.gnu.org/gnu/autoconf/autoconf-${ACONFVER}.tar.bz2 35# AT_M4DIR - Additional director(y|ies) aclocal should search
85# ftp://ftp.gnu.org/gnu/automake/automake-${AMAKEVER}.tar.bz2 36# AM_OPTS - Additional options to pass to automake during
86# ftp://alpha.gnu.org/gnu/automake/automake-${AMAKEVER}.tar.bz2" 37# eautoreconf call.
87SRC_URI="ftp://ftp.gnu.org/gnu/autoconf/autoconf-${ACONFVER}.tar.bz2
88 ftp://alpha.gnu.org/gnu/autoconf/autoconf-${ACONFVER}.tar.bz2
89 ftp://ftp.gnu.org/gnu/automake/automake-${AMAKEVER}.tar.bz2
90 ftp://alpha.gnu.org/gnu/automake/automake-${AMAKEVER}.tar.bz2"
91
92DEPEND="sys-devel/make
93 sys-devel/perl
94 >=sys-devel/m4-1.4o-r2"
95 38
39# Functions:
40#
41# eautoreconf() - Should do a full autoreconf - normally what most people
42# will be interested in. Also should handle additional
43# directories specified by AC_CONFIG_SUBDIRS.
44# eaclocal() - Runs aclocal. Respects AT_M4DIR for additional directories
45# to search for macro's.
46# _elibtoolize() - Runs libtoolize. Note the '_' prefix .. to not collide
47# with elibtoolize() from libtool.eclass
48# eautoconf - Runs autoconf.
49# eautoheader - Runs autoheader.
50# eautomake - Runs automake
51#
96 52
97AUTO_S="${WORKDIR}" 53# XXX: M4DIR should be depreciated
98AUTO_D="${T}/autotools" 54AT_M4DIR=${AT_M4DIR:-${M4DIR}}
55AT_GNUCONF_UPDATE="no"
99 56
100fetch_autotools() {
101 57
102 local y 58# This function mimes the behavior of autoreconf, but uses the different
103 for y in ${ASRC_URI} 59# eauto* functions to run the tools. It doesn't accept parameters, but
104 do 60# the directory with include files can be specified with AT_M4DIR variable.
105 if [ ! -e ${DISTDIR}/${y##*/} ] 61eautoreconf() {
106 then 62 local pwd=$(pwd) x auxdir
107 echo ">>> Fetching ${y##*/}..." 63
108 echo 64 if [[ -z ${AT_NO_RECURSIVE} ]]; then
109 local x 65 # Take care of subdirs
110 local _SRC_URI 66 for x in $(autotools_get_subdirs); do
111 for x in ${GENTOO_MIRRORS} 67 if [[ -d ${x} ]] ; then
112 do 68 cd "${x}"
113 _SRC_URI="${_SRC_URI} ${x}/distfiles/${y##*/}" 69 AT_NOELIBTOOLIZE="yes" eautoreconf
114 done 70 cd "${pwd}"
115 _SRC_URI="${_SRC_URI} `queryhost.sh "${SRC_URI}"`"
116 for x in ${_SRC_URI}
117 do
118 if [ ! -e ${DISTDIR}/${y##*/} ]
119 then
120 if [ "${y##*/}" = "${x##*/}" ]
121 then
122 echo ">>> Trying site ${x}..."
123 eval "${FETCHCOMMAND}"
124 fi
125 fi
126 done
127 if [ ! -e ${DISTDIR}/${y##*/} ]
128 then
129 echo '!!!'" Couldn't download ${y##*/} needed by autotools.eclass. Aborting."
130 exit 1
131 fi 71 fi
72 done
73 fi
74
75 auxdir=$(autotools_get_auxdir)
76
77 einfo "Running eautoreconf in '$(pwd)' ..."
78 [[ -n ${auxdir} ]] && mkdir -p ${auxdir}
79 eaclocal
80 _elibtoolize --copy --force
81 eautoconf
82 eautoheader
83 FROM_EAUTORECONF="yes" eautomake ${AM_OPTS}
84
85 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0
86
87 # Call it here to prevent failures due to elibtoolize called _before_
88 # eautoreconf.
89 elibtoolize
90
91 return 0
92}
93
94# These functions runs the autotools using autotools_run_tool with the
95# specified parametes. The name of the tool run is the same of the function
96# without e prefix.
97# They also force installing the support files for safety.
98eaclocal() {
99 local aclocal_opts
100
101 if [[ -n ${AT_M4DIR} ]] ; then
102 for x in ${AT_M4DIR} ; do
103 case "${x}" in
104 "-I")
105 # We handle it below
106 ;;
107 *)
108 [[ ! -d ${x} ]] && ewarn "eaclocal: '${x}' does not exist"
109 aclocal_opts="${aclocal_opts} -I ${x}"
110 ;;
111 esac
112 done
113 fi
114
115 autotools_set_versions
116 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \
117 autotools_run_tool aclocal "$@" ${aclocal_opts}
118}
119
120_elibtoolize() {
121 local opts
122 local lttest
123
124 # Check if we should run libtoolize (AM_PROG_LIBTOOL is an older macro,
125 # check for both it and the current AC_PROG_LIBTOOL)
126 lttest="$(autotools_check_macro "AC_PROG_LIBTOOL")$(autotools_check_macro "AM_PROG_LIBTOOL")"
127 [[ -n $lttest ]] || return 0
128
129 [[ -f Makefile.am ]] && opts="--automake"
130
131 [[ "${USERLAND}" == "Darwin" ]] && LIBTOOLIZE="glibtoolize"
132 autotools_run_tool ${LIBTOOLIZE:-libtoolize} "$@" ${opts}
133
134 # Need to rerun aclocal
135 eaclocal
136}
137
138eautoheader() {
139 # Check if we should run autoheader
140 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0
141 autotools_set_versions
142 autotools_run_tool autoheader "$@"
143}
144
145eautoconf() {
146 if [[ ! -f configure.ac && ! -f configure.in ]] ; then
132 echo 147 echo
133 fi 148 eerror "No configure.{ac,in} present in '$(pwd | sed -e 's:.*/::')'!"
134 done 149 echo
135} 150 die "No configure.{ac,in} present!"
151 fi
136 152
137unpack_autotools() { 153 autotools_set_versions
138 154 autotools_run_tool autoconf "$@"
139 cd ${AUTO_S}
140
141 local x
142 for x in ${ASRC_URI}
143 do
144 unpack ${x##*/} || die "!!! Could not unpack ${x##*/} needed by autotools !!!"
145 done
146} 155}
147 156
148install_autoconf() { 157eautomake() {
158 local extra_opts
149 159
150 cd ${AUTO_S}/autoconf-${ACONFVER} || die "!!! Failed to build autoconf !!!" 160 [[ -f Makefile.am ]] || return 0
151 161
152 ./configure --prefix=${AUTO_D} \ 162 autotools_set_versions
153 --infodir=${AUTO_D}/share/info \ 163 if [[ -z ${FROM_EAUTORECONF} && -f Makefile.in ]]; then
154 --mandir=${AUTO_D}/share/man \ 164 local used_automake
155 --target=${CHOST} || die "!!! Failed to configure autoconf !!!" 165 local installed_automake
156 166
157 emake || die "!!! Failed to build autoconf !!!" 167 installed_automake=$(automake --version | head -n 1 | \
168 sed -e 's:.*(GNU automake) ::')
169 used_automake=$(head -n 1 < Makefile.in | \
170 sed -e 's:.*by automake \(.*\) from .*:\1:')
158 171
159 make install || die "!!! Failed to install autoconf !!!" 172 if [[ ${installed_automake} != ${used_automake} ]]; then
160} 173 einfo "Automake used for the package (${used_automake}) differs from"
161 174 einfo "the installed version (${installed_automake})."
162install_automake() { 175 eautoreconf
163 176 return 0
164 cd ${AUTO_S}/automake-${AMAKEVER} || die "!!! Failed to build automake !!!"
165
166 ./configure --prefix=${AUTO_D} \
167 --infodir=${AUTO_D}/share/info \
168 --mandir=${AUTO_D}/share/man \
169 --target=${CHOST} || die "!!! Failed to configure automake !!!"
170
171 emake || die "!!! Failed to build automake !!!"
172
173 make install || die "!!! Failed to install automake !!!"
174}
175
176install_autotools() {
177
178 if [ "${SRC_URI/autoconf/}" = "$SRC_URI" ] || [ "${SRC_URI/automake/}" = "$SRC_URI" ]
179 then
180 echo "!!! \$SRC_URI was not set properly !!! It needs to include \${SRC_URI}"
181 exit 1
182 fi 177 fi
178 fi
183 179
184 if [ "${DEPEND/make/}" = "$DEPEND" ] || [ "${DEPEND/perl/}" = "$DEPEND" ] || \ 180 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS ]] \
185 [ "${DEPEND/m4/}" = "$DEPEND" ] 181 || extra_opts="${extra_opts} --foreign"
186 then 182
187 echo "!!! \$DEPEND was not set properly !!! It needs to include \${DEPEND}" 183 # --force-missing seems not to be recognized by some flavours of automake
188 exit 1 184 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@"
185}
186
187autotools_set_versions() {
188 [[ -n ${autotools_version_sets} ]] && return 0
189
190 if [[ -n ${WANT_AUTOCONF} ]]; then
191 [[ ${WANT_AUTOCONF} == "latest" ]] && WANT_AUTOCONF="2.5"
192 export WANT_AUTOCONF
193 einfo "Requested autoconf ${WANT_AUTOCONF}"
194 einfo "Using $(autoconf --version 2>/dev/null | head -n 1)"
195 einfo "Using $(autoheader --version 2>/dev/null | head -n 1)"
196 fi
197
198 if [[ -n ${WANT_AUTOMAKE} ]]; then
199 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
200 # Consider starting from 1.9, as that is stable everywhere.
201 has_version '~sys-devel/automake-1.9' && WANT_AUTOMAKE="1.9"
202 has_version '~sys-devel/automake-1.10' && WANT_AUTOMAKE="1.10"
189 fi 203 fi
204 export WANT_AUTOMAKE
205 einfo "Requested automake ${WANT_AUTOMAKE}"
206 einfo "Using $(automake --version 2>/dev/null | head -n 1)"
207 einfo "Using $(aclocal --version 2>/dev/null | head -n 1)"
208 fi
190 209
191 mkdir -p ${AUTO_S} 210 autotools_version_sets="yes"
192 mkdir -p ${AUTO_D}/{bin,etc,lib,include,share} \
193 || die "!!! Could not create needed directories for autotools !!!"
194
195# fetch_autotools
196# unpack_autotools
197 install_autoconf
198 install_automake
199
200 export PATH=${AUTO_D}/bin:${PATH}
201 cd ${S}
202 ln -sf ${AUTO_D}/share/automake/depcomp ${S}/depcomp
203} 211}
204 212
213# Internal function to run an autotools' tool
214autotools_run_tool() {
215 local STDERR_TARGET="${T}/$$.out"
216 local PATCH_TARGET="${T}/$$.patch"
217 local ris
218
219 echo "***** $1 *****" > ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/}
220 echo >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/}
221
222 ebegin "Running $@"
223 $@ >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 2>&1
224 ris=$?
225 eend ${ris}
226
227 if [[ ${ris} != 0 ]]; then
228 echo
229 eerror "Failed Running $1 !"
230 eerror
231 eerror "Include in your bugreport the contents of:"
232 eerror
233 eerror " ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/}"
234 echo
235 die "Failed Running $1 !"
236 fi
237}
238
239# Internal function to check for support
240autotools_check_macro() {
241 [[ -f configure.ac || -f configure.in ]] && \
242 WANT_AUTOCONF="2.5" autoconf --trace=$1 2>/dev/null
243 return 0
244}
245
246# Internal function to get additional subdirs to configure
247autotools_get_subdirs() {
248 local subdirs_scan_out
249
250 subdirs_scan_out=$(autotools_check_macro "AC_CONFIG_SUBDIRS")
251 [[ -n ${subdirs_scan_out} ]] || return 0
252
253 echo "${subdirs_scan_out}" | gawk \
254 '($0 !~ /^[[:space:]]*(#|dnl)/) {
255 if (match($0, /AC_CONFIG_SUBDIRS:(.*)$/, res))
256 print res[1]
257 }' | uniq
258
259 return 0
260}
261
262autotools_get_auxdir() {
263 local auxdir_scan_out
264
265 auxdir_scan_out=$(autotools_check_macro "AC_CONFIG_AUX_DIR")
266 [[ -n ${auxdir_scan_out} ]] || return 0
267
268 echo ${auxdir_scan_out} | gawk \
269 '($0 !~ /^[[:space:]]*(#|dnl)/) {
270 if (match($0, /AC_CONFIG_AUX_DIR:(.*)$/, res))
271 print res[1]
272 }' | uniq
273
274 return 0
275}

Legend:
Removed from v.1.6  
changed lines
  Added in v.1.48

  ViewVC Help
Powered by ViewVC 1.1.20